package it.polito.elite.protege.plugin.listeners;

import it.polito.elite.protege.plugin.OntoSpherePlugin;
import it.polito.elite.visualization.ontoviewer.scenes3D.SceneFocusConcept3;

import java.util.Collection;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;

import edu.stanford.smi.protege.model.Cls;
import edu.stanford.smi.protege.util.Selectable;
import edu.stanford.smi.protege.util.SelectionEvent;
import edu.stanford.smi.protege.util.SelectionListener;

public class ConceptSelectionListener implements SelectionListener
{
	//the panel that should be updated by this widget
	private OntoSpherePlugin plugin;
	
	private Logger logger;

	public ConceptSelectionListener(OntoSpherePlugin plugin)
	{
		super();
		// TODO Auto-generated constructor stub
		this.plugin = plugin;
		
		//creating a logger for debug / monitoring on the console
		this.logger = Logger.getLogger("it.polito.elite.ontology");
		//ConsoleHandler conHandler = new ConsoleHandler();
		//this.logger.addHandler(conHandler);
		
		//setting the defaul level at INFO
		this.logger.setLevel(Level.INFO);
	}

	public void selectionChanged(SelectionEvent arg0)
	{
		
		try
		{
		
			//getting the selectable item changed
			Selectable selectableItem = arg0.getSelectable();
		
			//getting the collection of selected items
			Collection selectedCollection = selectableItem.getSelection();
			
			//check if only one class has been selected
			if(selectedCollection.size() == 1)
			{
				//getting the collection iterator
				Iterator selectedIterator = selectedCollection.iterator();
				
				//getting the element
				Object selectedObject = selectedIterator.next();
			
				if(selectedObject instanceof Cls)
				{
					Cls selectedClass = (Cls)selectedObject;
			
					if((!selectedClass.isSystem())&&(selectedClass.isVisible()))
					{
						//getting the class name
						String selectedClassName = selectedClass.getName();
						
						this.logger.log(Level.INFO,"SELECTION EVENT: "+selectedClassName+" changing the panel view...");
						
						//changing the panel view
						SceneFocusConcept3 myScene = new SceneFocusConcept3(this.plugin.viewerPanel,
								selectedClassName);
						this.plugin.viewerPanel.changeScene(myScene);
					}
				}
			}
		}
		
		catch(NullPointerException nullE)
		{
			this.logger.log(Level.WARNING,"Null Pointer in ConceptSelectionListener: possibly a new class was created?");
		}
		
	}
}
