package it.polito.elite.protege.plugin.listeners;

import it.polito.elite.protege.plugin.OntoSpherePlugin;
import it.polito.elite.visualization.ontoviewer.scenes3D.SceneFocusConcept3;

import java.util.logging.Level;
import java.util.logging.Logger;

import edu.stanford.smi.protege.event.KnowledgeBaseAdapter;
import edu.stanford.smi.protege.event.KnowledgeBaseEvent;

public class ModelListener extends KnowledgeBaseAdapter
{

	//the panel that should be updated by this Listener
	private OntoSpherePlugin plugin;
	
	private Logger logger;
	
	public ModelListener(OntoSpherePlugin plugin)
	{
		super();
		
		//gets the plugin logger
		this.logger = Logger.getLogger("it.polito.elite.ontology");
		
		//stores a reference to the 3D panel
		this.plugin = plugin;
	}

	@Override
	public void clsCreated(KnowledgeBaseEvent arg0)
	{
		//call the default behavior 
		super.clsCreated(arg0);
		
		//logs the event
		this.logger.log(Level.WARNING, "detected class creation....");
		
		//refresh the 3D view
		this.plugin.resetViewer();
	}

	@Override
	public void clsDeleted(KnowledgeBaseEvent arg0)
	{
		// call the default behavior
		super.clsDeleted(arg0);
		
		//logs the event
		this.logger.log(Level.WARNING, "detected class deletion....");
		
		//refresh the 3D view
		this.plugin.resetViewer();
	}

	@Override
	public void frameNameChanged(KnowledgeBaseEvent arg0)
	{
		// TODO Auto-generated method stub
		super.frameNameChanged(arg0);
		
		//logs the event
		this.logger.log(Level.WARNING, "detected class renaming....");
		
		//refresh the 3D view
		this.plugin.resetViewer();
		
		//reload the scene
		if(this.plugin.isVisible()){
			SceneFocusConcept3 myScene = new SceneFocusConcept3(this.plugin.viewerPanel,
					arg0.getFrame().getName());
			this.plugin.viewerPanel.changeScene(myScene);
		}
	}
		

	@Override
	public void instanceCreated(KnowledgeBaseEvent arg0)
	{
		// TODO Auto-generated method stub
		super.instanceCreated(arg0);
		
		//logs the event
		this.logger.log(Level.WARNING, "detected instance creation....");
		
		//refresh the 3D view
		this.plugin.resetViewer();
	}

	@Override
	public void instanceDeleted(KnowledgeBaseEvent arg0)
	{
		// TODO Auto-generated method stub
		super.instanceDeleted(arg0);
		
		//logs the event
		this.logger.log(Level.WARNING, "detected instance deletion....");
		
		//refresh the 3D view
		this.plugin.resetViewer();
	}

	
}
