/*
 * Created on 20/mar/07
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.protege.plugin.listeners;

import it.polito.elite.protege.plugin.OntoSpherePlugin;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Collection;

import javax.swing.JTextArea;

import edu.stanford.smi.protegex.owl.model.OWLModel;
import edu.stanford.smi.protegex.owl.model.RDFProperty;
import edu.stanford.smi.protegex.owl.model.RDFSNamedClass;
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;
import edu.stanford.smi.protegex.owl.ui.dialogs.SelectionDialogFactory;

public class QueryCompositionListener implements ActionListener
{
	//the query text area
	private JTextArea queryArea;
	private OntoSpherePlugin plugin;
	private char currentVariableLetter = 'a';
	private int deepness = 0;
	
	public QueryCompositionListener (JTextArea queryArea, OntoSpherePlugin plugin)
	{
		this.queryArea = queryArea;	
		this.plugin = plugin;
	}

	public void actionPerformed(ActionEvent e)
	{
		//check which button has been clicked
		String actionCommand = e.getActionCommand();
		
		//gets the query area text
		StringBuffer queryText = new StringBuffer(this.queryArea.getText());
		
		//debug
		System.out.println ("queryText: "+queryText);
		
		//if not null
		if(actionCommand != null)
		{
			//manages the addition of class variables to the SPARQL query being
			//composed
			if(actionCommand.equals("addClassVariable"))
			{
				//checks if empty
				if(queryText.length()==0)
				{
					//adds the select clause
					String var = this.getVariable();
					
					queryText.append("SELECT ?"+var+" \n WHERE { ?"+var+" }");
					
					//call the update variable generation
					this.updateVariableLetter();
					
					//updating the text area
					this.queryArea.setText(queryText.toString());
					//this.queryArea.repaint();
				}
				//otherwise sholud split the query and add the new variable in the
				//correct places
				else
				{
					//TODO fix the insert process for multiple variables, should be
					//available a selection dialog for an already existing variable or for
					//a new variable, query concatenation shall be supported
					
					//delete the last brace
					int braceIndex = queryText.lastIndexOf("}");
					queryText.delete(braceIndex, queryText.length());
					
					//split the query in the select and where part
					
					//all the query to lower case
					String queryTextLower = queryText.toString().toLowerCase();
					
					//the boundaries of the select clause
					int selectBeginning = queryTextLower.indexOf("select");
					int selectEnd = queryTextLower.indexOf("where");
					
					//get the select clause
					String select = queryText.substring(selectBeginning+6,selectEnd);
					select = select.trim();
					
					//get the where clause
					String where = queryText.substring(selectEnd+5);
					where = where.trim();
					
					//getting the variable
					String var = this.getVariable();
					this.updateVariableLetter();
					
					//append the new variable to the select part
					select = select+" ?"+var;
					
					//append the new variable to the where part
					where = where+" ?"+var;
					
					//compose the query
					String  query = "SELECT "+select+"\n WHERE"+where+"}";
					
					//update the query field
					this.queryArea.setText(query);
				}
			}
			
			//manages the addition of named classes to the SPARQL query being
			//composed
			if(actionCommand.equals("addNamedClass"))
			{
				//pops up the class selection panel
				SelectionDialogFactory factory = ProtegeUI.getSelectionDialogFactory();
				
				//to change the knowledge base model for supporting getOWLModel
				OWLModel model = this.plugin.viewerPanel.model.getOWLModel();
				
				//check if the current model is OWL and in this case provides a class selection dialog
				if((model != null)&&(queryText.length()>0))
				{
					//get the selected class
					RDFSNamedClass selectedClass = factory.selectClass(null, model);
					
					//extract the class prefix
					String prefix = selectedClass.getNamespacePrefix();
					
					//check for null
					if(prefix == null) prefix="";
					
					//extract the class name
					String name = selectedClass.getName();
					
					//check for null, in case of null value, nothing is done
					if(name != null)
					{
						//delete the last brace
						int braceIndex = queryText.lastIndexOf("}");
						queryText.delete(braceIndex, queryText.length());
					
						//insert the class
						queryText.append(" "+prefix+":"+name+"}");
					
						//updating the text area
						this.queryArea.setText(queryText.toString());
					}
					
				}
			}
			
			//manages the addition of named classes to the SPARQL query being
			//composed
			if(actionCommand.equals("addNamedRelation"))
			{
				//pops up the class selection panel
				SelectionDialogFactory factory = ProtegeUI.getSelectionDialogFactory();
				
				//to change the knowledge base model for supporting getOWLModel
				OWLModel model = this.plugin.viewerPanel.model.getOWLModel();
				
				//check if the current model is OWL and in this case provides a class selection dialog
				if((model != null)&&(queryText.length()>0))
				{
					//get all available properties as a collection
					Collection properties = model.getRDFProperties();
					//get the selected class
					RDFProperty selectedRelation = factory.selectProperty(null, model, properties);
					
					//extract the class prefix
					String prefix = selectedRelation.getNamespacePrefix();
					
					//check for null
					if(prefix == null) prefix="";
					
					//extract the class name
					String name = selectedRelation.getName();
					
					//check for null, in case of null value, nothing is done
					if(name != null)
					{
						//avoid to duplicate the namespace
						int namespaceBoundary = name.lastIndexOf(':');
						
						//if a column character is found, delete the namespace
						if(namespaceBoundary > -1)
							name = name.substring(namespaceBoundary+1);
						
						//delete the last brace
						int braceIndex = queryText.lastIndexOf("}");
						queryText.delete(braceIndex, queryText.length());
					
						//insert the class
						queryText.append(" "+prefix+":"+name+"}");
					
						//updating the text area
						this.queryArea.setText(queryText.toString());
					}
					
				}
			}
			if(actionCommand.equals("addSelectConsequent"))
			{
				if(queryText.length()>0)
				{
					//adds a dot at the end of the select clause
					int braceIndex = queryText.lastIndexOf("}");
					
					//deletes the last brace of the select clause of the query
					queryText.delete(braceIndex, queryText.length());
					
					//adds a dot to the query
					queryText.append(" . }");
					
					//set the new textArea value
					queryArea.setText(queryText.toString());
				}
			}
		}

	}
	
	private void updateVariableLetter()
	{
		if(this.currentVariableLetter <= 'z')
			this.currentVariableLetter++;
		else
		{
			this.currentVariableLetter='a';
			this.deepness++;
		}
	}
	
	private String getVariable()
	{
		return Character.toString(this.currentVariableLetter)+this.deepness;
	}

}
