/*
 * Created on 20/mar/07
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.protege.plugin.listeners;

import it.polito.elite.protege.plugin.OntoSpherePlugin;
import it.polito.elite.visualization.ontoviewer.scenes3D.SceneFocusRoots1;
import it.polito.elite.visualization.ontoviewer.userInterfaces.SimpleSelectionTreePanel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashSet;

import javax.swing.DefaultListModel;
import javax.swing.JList;

/**
 * Action executed when the "add to View" button in the logic view panel is pressed
 * @author Alessio
 *
 */
public class RemoveFromViewListener implements ActionListener
{

	private JList resultList;
	private OntoSpherePlugin plugin;
	private DefaultListModel listModel;
	private SimpleSelectionTreePanel treePanel;
	
	public RemoveFromViewListener(JList resultList, DefaultListModel listModel, OntoSpherePlugin plugin)
	{
		this.resultList = resultList;
		this.plugin = plugin;
		this.listModel = listModel;
	}
	
	public RemoveFromViewListener(SimpleSelectionTreePanel treePanel, DefaultListModel listModel, OntoSpherePlugin plugin )
	{
		this.listModel = listModel;
		this.plugin = plugin;
		this.treePanel = treePanel;
	}
	
	public void actionPerformed(ActionEvent e)
	{
//		If no view is currently loaded or defined it creates a default current one
		boolean save2Model=true;
		if(this.plugin.viewerPanel.conceptsOfCurrentLogicView == null){
			this.plugin.viewerPanel.conceptsOfCurrentLogicView = new HashSet<String>();
			this.plugin.viewerPanel.conceptsOfCurrentLogicView.addAll( this.plugin.viewerPanel.model.getRoots() );
			this.plugin.viewerPanel.currentLogicViewName = new String ("noname");
			save2Model = false;
		}
//		iterating over the element in the result set and adding to the current working set
//		an hashset stored in pane3D that holds the elements pertaining to the current view
		Object[] elenco = null;
		if(this.resultList != null)
			elenco = this.resultList.getSelectedValues();
		else
			elenco = this.listModel.toArray();
		
		for(int i=0;i<elenco.length;i++){
			String resourceURI = (String) elenco[i];
			this.plugin.viewerPanel.conceptsOfCurrentLogicView.remove(resourceURI);
			//removing element from the data model 
			this.listModel.removeElement(elenco[i]);
		}
		// redraw component
		if(this.treePanel != null)
			this.treePanel.redrawTree();
		
		//saving the view in the model
		if(save2Model){
			this.plugin.viewerPanel.model.saveViewElements(this.plugin.viewerPanel.currentLogicViewName,
				this.plugin.viewerPanel.conceptsOfCurrentLogicView);
		}
		//creating a new view comprising the added elements
		SceneFocusRoots1 myScene = new SceneFocusRoots1(this.plugin.viewerPanel,
				this.plugin.viewerPanel.conceptsOfCurrentLogicView);
		this.plugin.viewerPanel.changeScene(myScene);

	}

}
