package it.polito.elite.visualization.ontoviewer.behaviors;

import java.awt.AWTEvent;
import java.awt.Component;
import java.awt.Cursor;
import java.awt.event.MouseEvent;
import java.util.Enumeration;
import java.util.Timer;

import javax.media.j3d.WakeupCriterion;
import javax.media.j3d.WakeupOnAWTEvent;

import com.sun.j3d.utils.behaviors.mouse.MouseBehavior;

public class MyMouseCursorSelector extends MouseBehavior{
	static final int tresholdTime= 300;
	
	private Component componente;
	private Timer myTimer;
	private boolean isCursorChanged;
	
	public MyMouseCursorSelector(Component componente)
	{
	     super(0);
	     this.componente=componente;
	     this.isCursorChanged=false;
	}


	public void processStimulus(Enumeration criteria) {
		WakeupCriterion wakeup;
		AWTEvent[] event;
		
		while (criteria.hasMoreElements()) {
			wakeup = (WakeupCriterion) criteria.nextElement();

			if (wakeup instanceof WakeupOnAWTEvent) {
				event = ((WakeupOnAWTEvent)wakeup).getAWTEvent();
				for (int i=0; i<event.length; i++) { 
					processMouseEvent((MouseEvent) event[i]);
				}
			}
		}
		wakeupOn (mouseCriterion);	
	}
	
	  /**
	   * Handles mouse events
	   */
	  public void processMouseEvent(MouseEvent evt) {
	    if (evt.getID()==MouseEvent.MOUSE_PRESSED) {
	    	myTimer=new Timer();
	    	ManageCursorChangeTT myTTask = new ManageCursorChangeTT(this.componente,evt.getButton(),this);
			myTimer.schedule(myTTask, MyMouseCursorSelector.tresholdTime);
	    }
	    else if (evt.getID()==MouseEvent.MOUSE_RELEASED){
	      if(this.myTimer!=null&&!this.isCursorChanged)
	    	  this.myTimer.cancel();
	      else{
	    	  this.componente.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	    	  this.isCursorChanged=false;
	      }
	    }    
	  }

	/**
	 * @param isCursorChanged The isCursorChanged to set.
	 */
	public void setCursorChanged(boolean isCursorChanged) {
		this.isCursorChanged = isCursorChanged;
	}
	  
	  
}
