package it.polito.elite.visualization.ontoviewer.models;

public class RelationType {
	private boolean isFunctional = false, isInverseFunctional = false, isTransitive = false, isSymmetric = false, hasInverse = false;
	private boolean isDatatype = false;
	private String inverseProperty = null;
	
	public RelationType(){}
	
	public boolean isObjectProperty(){
		return ! isDatatype;
	}
	
	public String getInverseProperty() {
		return inverseProperty;
	}
	
	public void setInverseProperty(String inverseProperty) {
		this.inverseProperty = inverseProperty;
		this.hasInverse = true;
	}
	public boolean isFunctional() {
		return isFunctional;
	}
	
	public void setFunctional(boolean isFunctional) {
		this.isFunctional = isFunctional;
	}
	
	public boolean isInverseFunctional() {
		return isInverseFunctional;
	}
	
	public void setInverseFunctional(boolean isInverseFunctional) {
		this.isInverseFunctional = isInverseFunctional;
	}
	
	public boolean isSymmetric() {
		return isSymmetric;
	}
	
	public void setSymmetric(boolean isSymmetric) {
		this.isSymmetric = isSymmetric;
	}
	
	public boolean isTransitive() {
		return isTransitive;
	}
	
	public void setTransitive(boolean isTransitive) {
		this.isTransitive = isTransitive;
	}
	
	public boolean hasInverse() {
		return hasInverse;
	}
	
	public boolean isSimple() {
		return !(isFunctional || isInverseFunctional || isTransitive || isSymmetric || hasInverse);
	}

	public boolean isDatatype() {
		return isDatatype;
	}

	public void setDatatype(boolean isDatatype) {
		this.isDatatype = isDatatype;
	}
	
	public String toString(){
		StringBuffer label = new StringBuffer();
		boolean firstElement = true;
		if(this.isFunctional){
			if(!firstElement)
				label = label.append(", ");
			label = label.append("Functional");
			firstElement=false;
		}
		if(this.isInverseFunctional){
			if(!firstElement)
				label = label.append(", ");
			label = label.append("Inverse functional");
			firstElement = false;
		}
		if(this.isSymmetric){
			if(!firstElement)
				label = label.append(", ");
			label = label.append("Symmetric");
			firstElement = false;
		}
		if(this.isTransitive){
			if(!firstElement)
				label = label.append(", ");
			label = label.append("Transisitive");
			firstElement = false;
		}
		if(this.hasInverse){
			if(!firstElement)
				label = label.append(", ");
			label = label.append("Inverse Of "+this.getInverseProperty());
			firstElement = false;
		}
		return label.toString().trim();
	}
}
