/*
 * Created on 17-nov-2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.visualization.ontoviewer.userInterfaces;

import it.polito.elite.protege.plugin.OntoSpherePlugin;
import it.polito.elite.protege.plugin.listeners.UpdateViewListener;
import it.polito.elite.visualization.ontoviewer.scenes3D.Scene3D;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.HashSet;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JColorChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.ScrollPaneConstants;
import javax.swing.SpinnerModel;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.vecmath.Color3f;



public class ControlPanel extends JPanel
{
	OntoSpherePlugin plugin;
	private final static int setterComponentHeight = 20, setterComponentWidth = 170, sizeOfHtmlToolTipInPixels=40;

	static final Class options = VisualizationOptions.class;
	
	public ControlPanel(OntoSpherePlugin plugin)
	{
		this.plugin = plugin;
		
		//setting the Panel Layout
		this.setLayout(new BorderLayout());
		
		/*****************************************
		 * The control panel contents            *
		 *****************************************/
		JPanel contentPanel = new JPanel();
		//setting a GridBagLayout for the control panel
		contentPanel.setLayout(new BoxLayout(contentPanel,BoxLayout.Y_AXIS));	
		contentPanel.add(Box.createVerticalStrut(1));
		//adds the second UI element
		JPanel labelPane=new JPanel(new FlowLayout());
		labelPane.setBackground(Color.LIGHT_GRAY);
		JLabel optionLabel = new JLabel("ONTOSPHERE3D - SETTINGS", 
				new ImageIcon(this.getClass().getClassLoader().getResource("resources/settings.gif")),  javax.swing.SwingConstants.LEFT);
		Font labelFont = new Font ("Arial",Font.BOLD,12);
		optionLabel.setFont(labelFont);
		optionLabel.setForeground(Color.WHITE);
		optionLabel.setAlignmentY(JLabel.LEFT_ALIGNMENT);
		labelPane.add(optionLabel);
		contentPanel.add(labelPane);
		
		JTabbedPane optionsSettings=new JTabbedPane();
		
		JScrollPane panelGeneral= this.createOptionsForSection(this.plugin, "G");
		ImageIcon iconGeneral=new ImageIcon(this.getClass().getClassLoader().getResource("resources/settings.gif"));
		optionsSettings.addTab("General", iconGeneral, panelGeneral, "Specify general behaviours and options");
		
		JScrollPane panelRelations= this.createOptionsForSection(this.plugin, "R");
		ImageIcon iconRelations=new ImageIcon(this.getClass().getClassLoader().getResource("resources/settings.gif"));
		optionsSettings.addTab("Relations", iconRelations, panelRelations, "Specify some options about the appearence of relations");
		
		for (int i = 1; i <= Scene3D.numScenes; i++) {
			JScrollPane panelScene= this.createOptionsForSection(this.plugin, ""+i);
			ImageIcon iconScene=new ImageIcon(this.getClass().getClassLoader().getResource("resources/settings.gif"));
			optionsSettings.addTab("Scene "+i, iconScene, panelScene,  "Specify general visualization options of scene "+1);
		}
		contentPanel.add(optionsSettings);
        
        this.add(contentPanel, BorderLayout.CENTER);
	}
	
	public JToolBar getToolBar()
	{
		JToolBar toolBar = new JToolBar();
		toolBar.setBackground(Color.WHITE);
		toolBar.setFloatable(false);
		
		
        JLabel ontosphere = new JLabel(new ImageIcon(this.getClass().getClassLoader().getResource("resources/ontosphere_logo_transparent32.gif")));
		toolBar.add(ontosphere);
		Dimension dim = new Dimension(18,32);
        toolBar.addSeparator(dim);
		
//		JButton buttonOptions = new JButton();
//        buttonOptions.setIcon(new ImageIcon(this.getClass().getClassLoader().getResource("resources/settings.gif")));
//        buttonOptions.addActionListener(new ActionListener()               
//        {                                                         
//            public void actionPerformed(ActionEvent e)               
//            {                                                        
//            	//set focus on the panel
//            }                                                        
//        });               
//        
//        buttonOptions.setBorderPainted(false);
//        buttonOptions.setToolTipText("Ontosphere - Options");
//        toolBar.add(buttonOptions);
        
        JButton updateViewButton = new JButton();
        updateViewButton.setIcon(new ImageIcon(this.getClass().getClassLoader().getResource("resources/refresh.gif")));
        updateViewButton.addActionListener(new UpdateViewListener(this.plugin));
        updateViewButton.setBorderPainted(false);
        updateViewButton.setToolTipText("Ontosphere - Update View");
        toolBar.add(updateViewButton);
        
        return toolBar;
	}
	
	private JScrollPane createOptionsForSection(OntoSpherePlugin myPlugin, String sectionID) {
		
		Field[] fields = options.getFields();
		JPanel sectionPanel = new JPanel();
		HashSet<JPanel> setSizes = new HashSet<JPanel>();
		HashSet<JPanel> setColors = new HashSet<JPanel>();

		for (int i = 0; i < fields.length; i++) {
			if (fields[i].getName().startsWith("s" + sectionID + "_")) {
				try {
					String s = fields[i].getName();
					String tooltipFieldStr = "descriptionOf_" + s;
					Field toolTipField = options.getField(tooltipFieldStr);
					String toolTipStr = (String) toolTipField.get(options);
					toolTipStr = this.createToolTipHTML(toolTipStr);
					
					String name = s.substring(3);
					String methodName = "setS" + sectionID + "_" + name;
					if (fields[i].getType() == java.lang.Float.TYPE) {
						float num = fields[i].getFloat(options);
						JPanel pan = createFloatOptionSetter(num, name,
								methodName, toolTipStr);
						setSizes.add(pan);
					} else if ((fields[i].getType() == java.lang.Integer.TYPE) ||
							(fields[i].getType() == java.lang.Long.TYPE)){
						boolean isLong=(fields[i].getType() == java.lang.Long.TYPE);
						JPanel pan;
						if(!isLong){
							int num = fields[i].getInt(options);
							pan = createIntegerOptionSetter(num, name,
								methodName, toolTipStr,isLong);
						}
						else{
							long num = fields[i].getInt(options);
							pan = createIntegerOptionSetter(num, name,
								methodName, toolTipStr, isLong);
						}
						setSizes.add(pan);
					} else if (fields[i].getType() == java.lang.Boolean.TYPE) {
						boolean val = fields[i].getBoolean(options);
						JPanel pan = createBooleanOptionSetter(val, name,
								methodName, toolTipStr);
						setSizes.add(pan);
					} else if (fields[i].getType() == java.lang.String.class) {
						String str = (String) fields[i].get(options);
						JPanel pan = createStringOptionSetter(str, name,
								methodName, toolTipStr);
						setSizes.add(pan);
					} else if (fields[i].getType() == Color3f.class) {
						Color3f col = (Color3f) fields[i].get(options);
						JPanel b = createColorOptionSetter(col, name,
								methodName, toolTipStr);
						setColors.add(b);
					}
				} catch (Exception e1) {
					System.err.println(e1+" creating options for section "+fields[i].getName());
				}

			}// if
		}// for
		int tot = setSizes.size() + setColors.size();
		
		sectionPanel.setMinimumSize(new Dimension (ControlPanel.setterComponentWidth, ControlPanel.setterComponentHeight*tot));
		sectionPanel.setLayout(new BoxLayout(sectionPanel, BoxLayout.Y_AXIS));
		sectionPanel.setBackground(Color.LIGHT_GRAY);
		
		for (JPanel p : setSizes)
			sectionPanel.add(p);

		for (JPanel b : setColors)
			sectionPanel.add(b);

		// other stuff
		JScrollPane scrollableSection=new  JScrollPane(sectionPanel);
		scrollableSection.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollableSection.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		return scrollableSection;
		
	}

	static private JPanel createFloatOptionSetter(float f, final String name,
			final String setterMethod, String toolTipText) {
		SpinnerModel model = new SpinnerNumberModel(f, 0, 4 * f, .1 * f);
		final JSpinner jspinner = new JSpinner(model);
		jspinner.setMaximumSize(new Dimension(ControlPanel.setterComponentWidth/3, ControlPanel.setterComponentHeight) );
		jspinner.addChangeListener(new ChangeListener() {

			public void stateChanged(ChangeEvent e) {
				Double d = (Double) (jspinner.getValue());
				float f = d.floatValue();
				Class options = VisualizationOptions.class;
				Class[] classes = new Class[1];
				classes[0] = java.lang.Float.TYPE;
				String s = new String(setterMethod);
				try {
					Method metodo = options.getMethod(s, classes);
					Object[] objs = new Object[1];
					objs[0] = new Float(f);
					metodo.invoke(options, objs);
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}

		});

		JLabel lab = new JLabel(name, JLabel.CENTER);
		lab.setToolTipText(toolTipText);
		JPanel pan = new JPanel(new FlowLayout(FlowLayout.CENTER));
		pan.add(lab);
		pan.add(jspinner);
		pan.setBorder(BorderFactory.createLineBorder(Color.BLACK));

		return pan;
	}

	static private JPanel createIntegerOptionSetter(long l, final String name,
			final String setterMethod, String toolTipText, final boolean isLong) {
		int base=(int) l;
		SpinnerModel model = new SpinnerNumberModel(base, 0, 2*base, base/50);
		final JSpinner jspinner = new JSpinner(model);
		jspinner.setMaximumSize(new Dimension(ControlPanel.setterComponentWidth/3, ControlPanel.setterComponentHeight) );
		jspinner.addChangeListener(new ChangeListener() {

			public void stateChanged(ChangeEvent e) {
				Double d = (Double) (jspinner.getValue());
				Class options = VisualizationOptions.class;
				Class[] classes = new Class[1];
				classes[0] = java.lang.Integer.TYPE;
				String s = new String(setterMethod);
				try {
					Method metodo = options.getMethod(s, classes);
					Object[] objs = new Object[1];
					if(isLong)
						objs[0] = new Long(d.longValue());
					else
						objs[0] = new Integer(d.intValue());
					metodo.invoke(options, objs);
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}

		});

		JLabel lab = new JLabel(name, JLabel.CENTER);
		lab.setToolTipText(toolTipText);
		JPanel pan = new JPanel(new FlowLayout(FlowLayout.CENTER));
		pan.add(lab);
		pan.add(jspinner);
		pan.setBorder(BorderFactory.createLineBorder(Color.BLACK));

		return pan;
	}
	
	private JPanel createBooleanOptionSetter(boolean val,
			final String name, final String setterMethod, String toolTipText) {
		final JCheckBox jcheckb = new JCheckBox(name, val);
		jcheckb.setToolTipText(toolTipText);
		jcheckb.addChangeListener(new ChangeListener() {

			public void stateChanged(ChangeEvent e) {
				boolean b = jcheckb.isSelected();
				Class options = VisualizationOptions.class;
				Class[] classes = new Class[1];
				classes[0] = java.lang.Boolean.TYPE;
				String s = new String(setterMethod);
				try {
					Method metodo = options.getMethod(s, classes);
					Object[] objs = new Object[1];
					objs[0] = new Boolean(b);
					metodo.invoke(options, objs);
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}

		});
		
		JPanel pan = new JPanel(new FlowLayout(FlowLayout.CENTER));
		pan.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		pan.add(jcheckb);
		
		return pan;
	}

	 private JPanel createStringOptionSetter(String val,
			final String name, final String setterMethod, String toolTipText) {
		final JTextField txt = new JTextField(val);
		txt.addFocusListener(new FocusListener() {
			public void focusGained(FocusEvent arg0) {
			}

			public void focusLost(FocusEvent arg0) {
				String str = txt.getText();
				Class options = VisualizationOptions.class;
				Class[] classes = new Class[1];
				classes[0] = java.lang.String.class;
				String s = new String(setterMethod);
				try {
					Method metodo = options.getMethod(s, classes);
					Object[] objs = new Object[1];
					objs[0] = str;
					metodo.invoke(options, objs);
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}

		});

		JLabel lab = new JLabel(name, JLabel.CENTER);
		lab.setToolTipText(toolTipText);
		JPanel pan = new JPanel(new FlowLayout(FlowLayout.CENTER));
		pan.add(lab);
		pan.add(txt);
		pan.setBorder(BorderFactory.createLineBorder(Color.BLACK));

		return pan;
	}

	 private JPanel createColorOptionSetter(Color3f col, String name,
			final String methodName, String toolTipText) {
		final JButton b = new JButton(name);
		b.setPreferredSize(new Dimension(ControlPanel.setterComponentWidth,ControlPanel.setterComponentHeight) );
		b.setToolTipText(toolTipText);
		b.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		final Color colore = new Color(col.x, col.y, col.z);
		b.setBackground(colore);
		float mediaCompColore=(col.x+col.y+col.z)/3;
		if(mediaCompColore>0.5f)
			b.setForeground(Color.BLACK);
		else
			b.setForeground(Color.WHITE);
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Color c = JColorChooser.showDialog(null, "Choose a color...",
						colore);
				b.setBackground(c);
				Class options = VisualizationOptions.class;
				Class[] classes = new Class[1];
				classes[0] = Color3f.class;
				try {
					Method metodo = options.getMethod(methodName, classes);
					Object[] objs = new Object[1];
					Color3f col = new Color3f((float) c.getRed() / 255,
							(float) c.getGreen() / 255,
							(float) c.getBlue() / 255);
					objs[0] = col;
					metodo.invoke(options, objs);
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
		});
		
		JPanel pan = new JPanel(new FlowLayout(FlowLayout.CENTER));
		pan.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		pan.add(b);
		
		return pan;
	}
	
	private String createToolTipHTML(String txt){
		String s=txt;
		String result=new String("<html>");
		while(s.length()> ControlPanel.sizeOfHtmlToolTipInPixels){
			int idx=s.indexOf(' ',ControlPanel.sizeOfHtmlToolTipInPixels);
			if(idx>0){
				String tmp=s.substring(0,idx).trim();
				s=s.substring(idx).trim();
				result+=tmp+"<br>";
			}
			else{
				result+=s;
				s="";
			}
		}
		result +=s+"</html>";
		return result;	
	}
	
}
