/*
 * Created on 17-nov-2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.polito.elite.visualization.ontoviewer.userInterfaces;

import it.polito.elite.protege.plugin.OntoSpherePlugin;
import it.polito.elite.protege.plugin.listeners.AddToViewListener;
import it.polito.elite.protege.plugin.listeners.ListUIEnabler;
import it.polito.elite.protege.plugin.listeners.QueryCompositionListener;
import it.polito.elite.protege.plugin.listeners.QueryListener;
import it.polito.elite.protege.plugin.listeners.RemoveFromViewListener;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JToolBar;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;

public class QueryPanel extends JPanel
{
	/**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = -1003476137325736416L;
	private OntoSpherePlugin plugin;
	private JTextArea queryText;
	private DefaultListModel resList;
	private JButton execButton;
	
	public QueryPanel (OntoSpherePlugin plugin)
	{
		//take a reference to the plugin
		this.plugin = plugin;
		
		//setting the Panel Layout
		this.setLayout(new BorderLayout());
		//this.setBorder(BorderFactory.createLineBorder(Color.black));
	
		
		/*****************************************
		 * The query folder title                 *
		 *****************************************/
		
		//adding the title bar to the query panel
		//this.add(this.createHeading("LOGIC VIEWS - QUERY"), BorderLayout.NORTH);
		
		
		/*****************************************
		 * The query folder contents              *
		 *****************************************/
		
		//Creating the panel object
		JPanel contentPanel = new JPanel();
		
		//setting a GridBagLayout for the control panel
		contentPanel.setLayout(new BoxLayout(contentPanel,BoxLayout.Y_AXIS));
		
		//Adding a vertical space from the top
		contentPanel.add(Box.createVerticalStrut(1));
	
		//adding the query input panel
		contentPanel.add(this.createQueryInputPanel());
		
		contentPanel.add(Box.createVerticalStrut(1));
		contentPanel.add(this.createQueryOutputPanel());
		
		this.execButton.addActionListener(new QueryListener(this.queryText, this.resList, this.plugin));
		
		this.add(contentPanel, BorderLayout.CENTER);
	}
	
	/**
	 * This method allows the creation of the title bar for the query tab of the 
	 * ontosphere3D control interface. It returns the title bar as a JPanel.
	 * @return the title bar as a JPanel
	 */
	private JPanel createHeading(String title)
	{
		//setting the title
		JLabel panelTitle = new JLabel(title);
		
		//setting the font
		Font labelFont = new Font ("SansSerif",Font.BOLD,12);
		panelTitle.setFont(labelFont);
		
		//setting the foreground color
		panelTitle.setForeground(Color.WHITE);
		
		//loading the panel icon (a circle with a question mark inside)
		JLabel panelIcon = new JLabel(new ImageIcon(this.getClass().getClassLoader().getResource("resources/SPARQLlogicViews.gif")));
		
		//creating the container for the title bar
		JPanel titleContainer = new JPanel();
		
		//setting the container layout
		titleContainer.setLayout(new FlowLayout());
		
		//setting the container background color
		titleContainer.setBackground(Color.LIGHT_GRAY);
		
		//adding the title bar components
		titleContainer.add(panelIcon);
		titleContainer.add(panelTitle);
		
		return titleContainer;
	}
	
	/**
	 * This method allows the creation of the query input panel for the query tab of
	 * OntoSphere3D. the query input panel is returned as a JPanel, and some of the 
	 * instance variable are initialized...
	 * 
	 * @return	the query input panel
	 */
	private JPanel createQueryInputPanel()
	{
		//Creating the query panel in which the query text will appear
		JPanel qInput = new JPanel();
		
		//setting the border  of the panel containing the query text
		qInput.setBorder(new TitledBorder(new LineBorder(Color.DARK_GRAY,1),"Query"));
		
		//setting the query panel layout
		qInput.setLayout(new BoxLayout(qInput,BoxLayout.Y_AXIS));
				
		//create the query text area (3 rows, 20 cols)
		this.queryText = new JTextArea(3,20);
		
		//make the area scrollable
		JScrollPane scrollText = new JScrollPane(this.queryText);
		
		//add a vertical space
		qInput.add(Box.createVerticalStrut(1));
		
		//add the query text area
		qInput.add(scrollText);
		
		/************************ QUERY COMPOSITION INTERFACE ********************/
		
		//create the query composition panel
		JPanel queryCompPanel = new JPanel();
		
		//create the toolbar for query elements 
		JToolBar queryTools = new JToolBar();
		
		//fixing the toolbar
		queryTools.setFloatable(false);
		
		//creating the query composition listener
		QueryCompositionListener qListen = new QueryCompositionListener(this.queryText, this.plugin);
		
		/*
		 * creating the interface for adding an UNKNOWN CLASS to the query
		 * i.e., to add a class variable
		 */
		
		//loading the unknown class icon
		Icon addClassVariableIcon = new ImageIcon(this.getClass().getClassLoader().getResource("resources/classVariable.gif"));
		
		//creating the unknown class button
		JButton classVariableButton = new JButton(addClassVariableIcon);
		
		//hiding the button border
		classVariableButton.setBorderPainted(false);
		
		//setting the tooltip text
		classVariableButton.setToolTipText("Add a Class variable");
		
		//setting the button action
		classVariableButton.setActionCommand("addClassVariable");
		
		//adding the query composition listener
		classVariableButton.addActionListener(qListen);
		
		//add the button to the query toolbar
		queryTools.add(classVariableButton);
		
		
		/*
		 * creating the interface for adding a NAMED CLASS to the query
		 * i.e., to add a class whose name is known
		 */
		
		//loading the named class icon
		Icon addNamedClassIcon = new ImageIcon(this.getClass().getClassLoader().getResource("resources/namedClass.gif"));
		
		//adding the named class button
		JButton namedClassButton = new JButton(addNamedClassIcon);
		
		//hiding the button border
		namedClassButton.setBorderPainted(false);
		
		//setting the tooltip text
		namedClassButton.setToolTipText("Add a Named Class");
		
		//setting the button action
		namedClassButton.setActionCommand("addNamedClass");
		
		//adding the query composition listener
		namedClassButton.addActionListener(qListen);
		
		//add the button to the query toolbar
		queryTools.add(namedClassButton);
		
		
		/*
		 * creating the interface for adding a UNKNOWN RELATION to the query
		 * i.e., to add a relation variable
		 */
		
		//loading the unknown relation icon
		Icon addRelationVariableIcon = new ImageIcon(this.getClass().getClassLoader().getResource("resources/relationVariable.gif"));
		
		//creating the unknown relation button
		JButton relationVariableButton = new JButton(addRelationVariableIcon);
		
		//hiding the border
		relationVariableButton.setBorderPainted(false);
		
		//setting the tooltip text
		relationVariableButton.setToolTipText("Add a Relation variable");
		
		//setting the button action
		relationVariableButton.setActionCommand("addRelationVariable");
		
		//add the button to the query toolbar
		queryTools.add(relationVariableButton);
		
		/*
		 * creating the interface for adding a NAMED RELATION to the query
		 * i.e., to add a relation whose name is known
		 */
		
		//loading the named relation icon
		Icon addNamedRelationIcon = new ImageIcon(this.getClass().getClassLoader().getResource("resources/namedRelation.gif"));
		
		//create the named relation button
		JButton namedRelationButton = new JButton(addNamedRelationIcon);
		
		//hiding the button border
		namedRelationButton.setBorderPainted(false);
		
		//setting the tooltip text
		namedRelationButton.setToolTipText("Add a Named Relation");
		
		//setting the button action
		namedRelationButton.setActionCommand("addNamedRelation");
		
		//adding the query composition listener
		namedRelationButton.addActionListener(qListen);
		
		//add the button to the query toolbar
		queryTools.add(namedRelationButton);
		
		/*
		 * creating the interface for adding a consequent to the where clause 
		 * i.e., to add multiple conditions to be satisfied b query elements
		 */
		//loading the named relation icon
		Icon addSelectConsequentIcon = new ImageIcon(this.getClass().getClassLoader().getResource("resources/addConsequent.gif"));
		
		//create the named relation button
		JButton selectConsequentButton = new JButton(addSelectConsequentIcon);
		
		//hiding the button border
		selectConsequentButton.setBorderPainted(false);
		
		//setting the tooltip text
		selectConsequentButton.setToolTipText("Add a Consequent");
		
		//setting the button action
		selectConsequentButton.setActionCommand("addSelectConsequent");
		
		//adding the query composition listener
		selectConsequentButton.addActionListener(qListen);
		
		//add the button to the query toolbar
		queryTools.add(selectConsequentButton);
		
		/*
		 * creating the interface for adding a consequent to the where clause 
		 * i.e., to add multiple conditions to be satisfied b query elements
		 */
		//loading the named relation icon
		Icon queryWizardIcon = new ImageIcon(this.getClass().getClassLoader().getResource("resources/wizard.gif"));
		
		//create the named relation button
		JButton queryWizardButton = new JButton(queryWizardIcon);
		
		//hiding the button border
		queryWizardButton.setBorderPainted(false);
		
		//setting the tooltip text
		queryWizardButton.setToolTipText("Query Wizard");
		
		//setting the button action
		queryWizardButton.setActionCommand("wizard");
		
		//adding the query composition listener
		queryWizardButton.addActionListener(qListen);
		
		//add the button to the query toolbar
		queryTools.add(queryWizardButton);
				
		//add the query toolbar
		queryCompPanel.add(queryTools);
		
		//add a vertical space
		qInput.add(Box.createVerticalStrut(1));
		//add the query composition Panel
		qInput.add(queryCompPanel);
		
		
		/*********************** EXECUTE BUTTON ***********************************/
		this.execButton = new JButton("Execute");
		this.execButton.setIcon(new ImageIcon(this.getClass().getClassLoader().getResource("resources/Bomb.gif")));
		
		qInput.add(Box.createVerticalStrut(1));
		qInput.add(this.execButton);
		
		return qInput;
	}
	
	/**
	 * This method allows the creation of the query output panel for the query tab of
	 * OntoSphere3D. the query output panel is returned as a JPanel, and some of the 
	 * instance variable are initialized...
	 * 
	 * @return	the query output panel
	 */
	private JPanel createQueryOutputPanel()
	{
		JPanel qOutput = new JPanel();
		qOutput.setLayout(new BoxLayout(qOutput,BoxLayout.Y_AXIS));
		qOutput.setBorder(new TitledBorder(new LineBorder(Color.DARK_GRAY,1),"Results"));
		
		this.resList = new DefaultListModel();
		ListUIEnabler listUIListener = new ListUIEnabler(this.resList);
		this.resList.addListDataListener(listUIListener);
		JList list = new JList(this.resList);
		JScrollPane scrollList = new JScrollPane(list);
		qOutput.add(scrollList);
		
		JPanel buttonPane = new JPanel();
		buttonPane.setLayout(new FlowLayout());
		
		JButton addButton = new JButton("Add to view");
		addButton.setIcon(new ImageIcon(this.getClass().getClassLoader().getResource("resources/add_class.gif")));
		addButton.setEnabled(false);
		addButton.addActionListener(new AddToViewListener(list, this.resList, this.plugin));
		listUIListener.add(addButton);
		JButton clearButton = new JButton("Clear");
		clearButton.setIcon(new ImageIcon(this.getClass().getClassLoader().getResource("resources/trashResults.gif")));
		clearButton.setEnabled(false);
		clearButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				resList.clear();
			}
		});
		listUIListener.add(clearButton);
		JButton removeButton = new JButton("Remove from view");
		removeButton.setIcon(new ImageIcon(this.getClass().getClassLoader().getResource("resources/del_class.gif")));
		removeButton.setEnabled(false);
		removeButton.addActionListener(new RemoveFromViewListener(list, this.resList, this.plugin));
		listUIListener.add(removeButton);
		
		buttonPane.add(removeButton);
		buttonPane.add(clearButton);
		buttonPane.add(addButton);
		
		qOutput.add(Box.createVerticalStrut(1));
		qOutput.add(buttonPane);
		
		return qOutput;
	}
}
